Index: res/res_musiconhold.c
===================================================================
--- res/res_musiconhold.c	(revision 376584)
+++ res/res_musiconhold.c	(working copy)
@@ -1375,6 +1375,7 @@
 	struct ast_variable *var = NULL;
 	int res;
 	int realtime_possible = ast_check_realtime("musiconhold");
+	const char *inqueue, *inqueue_membername;
 
 	/* The following is the order of preference for which class to use:
 	 * 1) The channels explicitly set musicclass, which should *only* be
@@ -1575,6 +1576,12 @@
 		ast_channel_name(chan), ast_channel_uniqueid(chan),
 		mohclass->name);
 
+	inqueue = pbx_builtin_getvar_helper(chan, "IN_QUEUE");
+	if (!ast_strlen_zero(inqueue)) {
+		inqueue_membername = pbx_builtin_getvar_helper(chan, "IN_QUEUE_MEMBERNAME");
+		ast_queue_log(inqueue, chan->uniqueid, inqueue_membername, "CALLERONHOLD", "%s", mohclass->name);
+	}
+ 
 	ast_set_flag(ast_channel_flags(chan), AST_FLAG_MOH);
 
 	if (mohclass->total_files) {
@@ -1590,6 +1597,8 @@
 
 static void local_ast_moh_stop(struct ast_channel *chan)
 {
+	const char *inqueue, *inqueue_membername;
+
 	ast_clear_flag(ast_channel_flags(chan), AST_FLAG_MOH);
 	ast_deactivate_generator(chan);
 
@@ -1606,6 +1615,11 @@
 		"Channel: %s\r\n"
 		"UniqueID: %s\r\n",
 		ast_channel_name(chan), ast_channel_uniqueid(chan));
+	inqueue = pbx_builtin_getvar_helper(chan, "IN_QUEUE");
+	if (!ast_strlen_zero(inqueue)) {
+		inqueue_membername = pbx_builtin_getvar_helper(chan, "IN_QUEUE_MEMBERNAME");
+		ast_queue_log(inqueue, chan->uniqueid, inqueue_membername, "CALLEROFFHOLD", "%s", "");
+	}
 	ast_channel_unlock(chan);
 }
 
Index: apps/app_queue.c
===================================================================
--- apps/app_queue.c	(revision 376584)
+++ apps/app_queue.c	(working copy)
@@ -5753,6 +5753,9 @@
 		ast_queue_log(queuename, ast_channel_uniqueid(qe->chan), member->membername, "CONNECT", "%ld|%s|%ld", (long) time(NULL) - qe->start, ast_channel_uniqueid(peer),
 													(long)(orig - to > 0 ? (orig - to) / 1000 : 0));
 
+		pbx_builtin_setvar_helper(qe->chan, "IN_QUEUE", qe->parent->name);
+		pbx_builtin_setvar_helper(qe->chan, "IN_QUEUE_MEMBERNAME", member->membername);
+
 		if (ast_channel_cdr(qe->chan)) {
 			struct ast_cdr *cdr;
 			struct ast_cdr *newcdr;
